-- p2sort (c) 2013 Dirk Laurie and Eike Decker
-- Posted on Lua-L by Eike Decker on 09 May 2013
-- Modularized and critical functions implemented in C API by DPL

-- Optimal max_chunk_size depends on many things: typical data, properties
--   of your system etc. 
local max_chunk_size = max_chunk_size or 16

-- if a global or upvalue core is given, it is not reloaded
local core=core or require"sort_core"
local small_sort = core.sort
local merge = core.merge
local min=math.min

local function p2sort( array, cmp )
   local n = #array
   if n < 2 then  return array  end
   if cmp and cmp(array[1],array[1]) then 
      error"invalid order function for sorting"
   end
   local step=max_chunk_size
   if chunk_size then step = chunk_size(n) end
   for i=1,n,step do small_sort(array, i, min(i+step-1,n), cmp) end
   while step<n do 
      for i=1,n,step*2 do if i+step<=n then 
         local m=min(i+2*step-1,n)
         merge(array,i,i+step-1,m,cmp)
      end end 
      step=step*2
   end
   return array
end

return p2sort

